using ReactiveUI;

namespace LoraGamepad.Models;


public class SliderConfig : ReactiveObject
{
    private double _rightHorizonValue;
    private double _rightVerticalValue;
    private double _leftHorizonValue;
    private double _lefttVerticalValue;

    private double _leftUpValue = 0;
    private double _midLeftValue = 0;
    private double _midRightValue = 0;
    public SliderConfig()
    {
        _rightHorizonValue = _rightVerticalValue = _leftHorizonValue = _lefttVerticalValue = 0;
    }
    
    public double RightHorizonValue
    {
        get => _rightHorizonValue;
        set => this.RaiseAndSetIfChanged(ref _rightHorizonValue, value);
    }
    
    public double RightVerticalValue
    {
        get => _rightVerticalValue;
        set => this.RaiseAndSetIfChanged(ref _rightVerticalValue, value);
    }
    public double LeftHorizonValue
    {
        get => _leftHorizonValue;
        set => this.RaiseAndSetIfChanged(ref _leftHorizonValue, value);
    }
    public double LeftVerticalValue
    {
        get => _lefttVerticalValue;
        set => this.RaiseAndSetIfChanged(ref _lefttVerticalValue, value);
    }
    public double LeftUpValue
    {
        get => _leftUpValue;
        set => this.RaiseAndSetIfChanged(ref _leftUpValue, value);
    }
    public double MidLeftValue
    {
        get => _midLeftValue;
        set => this.RaiseAndSetIfChanged(ref _midLeftValue, value);
    }
    public double MidRightValue
    {
        get => _midRightValue;
        set => this.RaiseAndSetIfChanged(ref _midRightValue, value);
    }
}